﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ComponentModel.Composition;
using System.Text;

namespace Contracts
{
    [MetadataAttribute]
    [AttributeUsage(AttributeTargets.Class)]
    public class WpfServiceMetadataAttribute : ExportAttribute
    {
        public WpfServiceMetadataAttribute()
            : this("", "")
        {
        }

        public WpfServiceMetadataAttribute(string name)
            : this(name, "")
        {
        }

        public WpfServiceMetadataAttribute(string name, string version)
            : base(typeof(IWpfService))
        {
            this.ServiceName = name;
            this.ServiceVersion = version;
        }

        public string ServiceName { get; private set; }
        public string ServiceVersion { get; private set; }
    }
}
